VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.MDIForm FormMain 
   BackColor       =   &H8000000C&
   Caption         =   "SixPap: Simplex / Push and Pull"
   ClientHeight    =   9735
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   10110
   LinkTopic       =   "MDIForm1"
   ScrollBars      =   0   'False
   StartUpPosition =   3  'Windows Default
   WindowState     =   2  'Maximized
   Begin MSComDlg.CommonDialog CommonDialogHelp 
      Left            =   180
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu MenuExit 
      Caption         =   "E&xit"
      NegotiatePosition=   3  'Right
   End
   Begin VB.Menu MenuRepository 
      Caption         =   "&Repository"
   End
   Begin VB.Menu MenuProblem 
      Caption         =   "Single &Problem"
   End
   Begin VB.Menu MenuAnalysis 
      Caption         =   "&Analysis"
   End
   Begin VB.Menu MenuWindow 
      Caption         =   "&Window"
      NegotiatePosition=   3  'Right
      WindowList      =   -1  'True
      Begin VB.Menu MenuWindowArrange 
         Caption         =   "&Cascade"
         Index           =   0
      End
      Begin VB.Menu MenuWindowArrange 
         Caption         =   "&Horizontal ="
         Index           =   1
      End
      Begin VB.Menu MenuWindowArrange 
         Caption         =   "&Vertical ||"
         Index           =   2
      End
      Begin VB.Menu MenuWindowArrange 
         Caption         =   "&Default"
         Index           =   3
      End
   End
   Begin VB.Menu MenuHelp 
      Caption         =   "&Help"
      NegotiatePosition=   3  'Right
      Begin VB.Menu MenuHelpInstructions 
         Caption         =   "&Help Topics"
      End
      Begin VB.Menu MenuHelpLine 
         Caption         =   "-"
         Index           =   1
      End
      Begin VB.Menu MenuHelpAbout 
         Caption         =   "&About"
      End
   End
End
Attribute VB_Name = "FormMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'   MDI FORM MAIN: APPLICATION CONTAINER

Private ArrangeState As Integer    ' type of child windows arranging

'
'   load main form
'
Private Sub MDIForm_Load()

    MenuWindowArrange_Click 3

End Sub

Private Sub MDIForm_QueryUnload(Cancel As Integer, UnloadMode As Integer)

    If Not FormSingleProblem.TestCurrentForSave Then Exit Sub
    
    End

End Sub


'
'   Main form resize
'
Private Sub MDIForm_Resize()

    If Me.WindowState <> 1 Then
    
        MenuWindowArrange_Click ArrangeState
    
    End If

End Sub


'
'   exit application
'
Private Sub MenuExit_Click()
    
    If Not FormSingleProblem.TestCurrentForSave Then Exit Sub
    End

End Sub

'
'   Activate help
'
Private Sub MenuHelpInstructions_Click()

    With CommonDialogHelp
    
        .HelpFile = App.HelpFile
        .HelpContext = 1
        .HelpCommand = cdlHelpContext
        .ShowHelp
    
    End With

End Sub

'
'   menu Repository click
'
Private Sub MenuRepository_Click()

    FormRepository.SetFocus
    If FormRepository.WindowState = 1 Then FormRepository.WindowState = 0
    
End Sub

'
'   activate the single problem window
'
Private Sub MenuProblem_Click()

    FormSingleProblem.SetFocus
    If FormSingleProblem.WindowState = 1 Then FormSingleProblem.WindowState = 0

End Sub

'
'   activate the analysis window
'
Private Sub MenuAnalysis_Click()
    
    FormAnalysis.SetFocus
    If FormAnalysis.WindowState = 1 Then FormAnalysis.WindowState = 0

End Sub

'
'   arrange windows
'
Private Sub MenuWindowArrange_Click(Index As Integer)
    
    If Index < 3 Then
    
        Me.Arrange Index
        
    Else
    
        SetDefaultPosition
    
    End If
    
    ArrangeState = Index
    
End Sub

'
'   show about box
'
Private Sub MenuHelpAbout_Click()
    
    FormAbout.Show 1, Me

End Sub

'
'   set default position of the child forms
'
Public Sub SetDefaultPosition()

    Dim tempWidth As Long

    With FormRepository
        .Show
        .WindowState = 0
        .Move 0, 0, FormRepository.SignificantWidth, Me.ScaleHeight
    End With
    
    With FormSingleProblem
        .Show
        .WindowState = 0
        tempWidth = Me.ScaleWidth - FormRepository.Width
        If tempWidth > 0 Then _
            .Move FormRepository.Width, 0, tempWidth, Me.ScaleHeight / 2
            
    End With
    
    With FormAnalysis
        .Show
        .WindowState = 0
        tempWidth = Me.ScaleWidth - FormRepository.Width
        If tempWidth > 0 Then .Move FormRepository.Width, Me.ScaleHeight / 2, _
              tempWidth, Me.ScaleHeight / 2
              
    End With
    
    FormRepository.SetFocus
    
    Docked = True
    
End Sub








