Attribute VB_Name = "ModuleMain"

'   MODULE MAIN: ENTRY POINT OF THE APPLICATION

Public lastOpenProblemDir As String         ' store last open directory

Public lastImportProblemDir As String       ' store last import directory

Public lastSaveProblemDir As String         ' store last save directory

Public lastSaveAnalysisDir As String        ' store last save directory

Public selectedProblemFolder As String      ' selected problem folder: adding to analysis

Public RepositoryFolder As String
Public TrashFolder As String


Public runningExe As Boolean


'
' application entry point
'
Public Sub Main()
    
    runningExe = (App.EXEName = "SixPap")
        
    Dim devTest As String
    devTest = IIf(runningExe, "", "\..")
    
'    ModuleMain.RepositoryFolder = App.Path & devTest & "\Repository"
    ModuleMain.RepositoryFolder = App.Path & "\Repository"
    ModuleMain.TrashFolder = RepositoryFolder & "\Trash"
    
'    App.HelpFile = App.Path & devTest & "\SixPap.hlp"
    App.HelpFile = App.Path & "\SixPap.hlp"
    
    
    '   test for nexessary folder existance, create if don't exist
    If Dir(RepositoryFolder, vbDirectory) = "" Then MkDir RepositoryFolder
    If Dir(RepositoryFolder & "\Solutions", vbDirectory) = "" Then MkDir RepositoryFolder & "\Solutions"
    If Dir(TrashFolder, vbDirectory) = "" Then MkDir TrashFolder
    If Dir(TrashFolder & "\Solutions", vbDirectory) = "" Then MkDir TrashFolder & "\Solutions"
    
    
'    lastSaveProblemDir = App.Path & devTest & "\Problems"
'    lastOpenProblemDir = App.Path & devTest & "\Problems"
'    lastImportProblemDir = App.Path & devTest
'    lastSaveAnalysisDir = App.Path & devTest & "\Analyses"
'    selectedProblemFolder = App.Path & devTest & "\Problems"
    
    FormSplash.Show 1
    
    Load FormMain
    Load FormSingleProblem
    Load FormAnalysis
    Load FormRepository
    
    FormMain.Show

'    FormMain.SetDefaultPosition
'    FormSingleProblem.NewProblem
    FormRepository.SetFocus
    
End Sub
