VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "Msflxgrd.ocx"
Begin VB.UserControl MyGrid 
   ClientHeight    =   2895
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4560
   ScaleHeight     =   2895
   ScaleWidth      =   4560
   Begin VB.TextBox tbCell 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   238
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   285
      Left            =   1575
      TabIndex        =   1
      Text            =   "cell"
      Top             =   1530
      Visible         =   0   'False
      Width           =   870
   End
   Begin MSFlexGridLib.MSFlexGrid fxgGrid 
      Height          =   1005
      Left            =   120
      TabIndex        =   0
      Top             =   420
      Width           =   3210
      _ExtentX        =   5662
      _ExtentY        =   1773
      _Version        =   393216
      BackColor       =   -2147483624
      BackColorBkg    =   -2147483633
      AllowBigSelection=   0   'False
      FocusRect       =   0
      HighLight       =   0
      GridLines       =   2
      MergeCells      =   4
      BorderStyle     =   0
      Appearance      =   0
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.Label LabelToggleSelectAll 
      AutoSize        =   -1  'True
      Caption         =   "Check All"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   210
      Left            =   420
      TabIndex        =   3
      Top             =   120
      Width           =   780
   End
   Begin VB.Label LabelSelectAll 
      Alignment       =   2  'Center
      Caption         =   ""
      BeginProperty Font 
         Name            =   "Wingdings"
         Size            =   9.75
         Charset         =   2
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   225
      Left            =   0
      TabIndex        =   2
      Top             =   120
      Width           =   405
   End
End
Attribute VB_Name = "MyGrid"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'-----------------------------------------------------------------
' TO DO:
'   - camelType, PascalType
'   - redimensioning
'   - resize
'   - edit fields
'   - change values and redim columns
'   - optimize code (work on redundancy)
'-----------------------------------------------------------------

Public EditEnabled As Boolean       ' allows editing fields with text box

Public ToggleSelectedEnabled As Boolean

Private cellWidths() As Long        ' contains all cell widths
Private cellLocked() As Boolean

Private columnHidden() As Boolean
Private Const defaultHiddenWidth As Long = 100

Private oldRedraw As Boolean
Private oldRow As Long
Private oldCol As Long

Public fxgHandle As MSFlexGrid
Public lblCheckHandle As Label

Private currentValueRow As Long

Private fieldOtherData()

Private Const errorNumberDataNotFound = 1000     ' search for MyGrid.OtherData failed

Private Const SelectedRowColor As Long = &H8000000D   '&HFFC0C0    '&H80000013
Private Const SelectedTextColor As Long = &H8000000E

Public currentRow As Long
Public currentCol As Long


Public Event CellValueChanged(editedRow As Long, editedCol As Long, newValue)

Public Event ItemSelected(newSelectedRow As Long)

Private editedRow As Long
Private editedCol As Long

Private tbCellValueChanged As Boolean

Public editError As Boolean

Private fieldCheckBoxed As Boolean
Private cellChecked() As Boolean

Public showSelectedRow As Boolean

Private fieldSelectedRow As Long

Private yValueTop As Long
Private yValueBottom As Long
Private xValueLeft As Long
Private xValueRight As Long
Private xCheckRight As Long

Public ValueColCount As Long

'   fields containing object data

Private Type FieldType

    ValueRowCount As Long
    selectedRowOriginalColour As Long

    doubleClick As Boolean

End Type

Private fields As FieldType

Private MouseIsDown As Boolean

Public CanHideColumn As Boolean
'
'   apply checking on relative row position
'
Public Sub ApplyCheck(checkedRow As Long)

    StoreOldAndFreeze
    
    cellChecked(checkedRow) = Not cellChecked(checkedRow)
    
    fxgGrid.Row = checkedRow + fxgGrid.FixedRows - 1
    fxgGrid.Col = 0

    fxgGrid.CellFontName = "Wingdings"
    fxgGrid.CellFontSize = 10
    fxgGrid.CellFontBold = True
    fxgGrid.CellAlignment = flexAlignCenterCenter

    fxgGrid.Text = IIf(cellChecked(checkedRow), "", " ")

    '   check how many checked
    
    CheckedCount

    RestoreOld

End Sub

'
'   set new cell value
'
Private Sub CellValueSet(SelectedRow As Long, _
                        selectedCol As Long, _
                        ByVal newValue As String)
                        
    fxgGrid.Row = SelectedRow
    fxgGrid.Col = selectedCol
    
    If fxgGrid.RowData(SelectedRow) Or fxgGrid.ColData(selectedCol) Then
        
        fxgGrid.CellFontBold = True
        fxgGrid.CellBackColor = fxgGrid.BackColorFixed
        
    Else
    
        fxgGrid.CellFontBold = False
        fxgGrid.CellBackColor = fxgGrid.BackColor
    
    End If
    
    SetAlignment newValue
    
    If Not Merging(newValue) Then
    
        fxgGrid.Text = newValue
        CalcCellWidth
    
    End If
    
End Sub



'
'   property let check abillity on or off
'
Public Property Let CheckBoxed(Optional LabelCaption As String = "Check All", _
                               newValue As Boolean)

    fieldCheckBoxed = newValue
    
    If newValue Then
    
        LabelToggleSelectAll.Visible = True
        LabelToggleSelectAll.Caption = LabelCaption
        LabelSelectAll.Visible = False
        
        fxgGrid.Top = LabelToggleSelectAll.Top + LabelToggleSelectAll.Height + 100
        fxgGrid.Height = UserControl.ScaleHeight - fxgGrid.Top
        
    End If

End Property

'
'   property get: check abillity on or off
'
Public Property Get CheckBoxed(Optional LabelCaption As String = "Check All") As Boolean

    CheckBoxed = fieldCheckBoxed
    
End Property


'
'   count checked
'
Public Function CheckedCount() As Long

    CheckedCount = 0
    
    Dim i As Long
    
    For i = 1 To UBound(cellChecked)
        
        If cellChecked(i) Then CheckedCount = CheckedCount + 1

    Next i

    Select Case CheckedCount
    
    Case 0
        
        LabelSelectAll.Visible = False
    
    Case ValueRowCount
        
        LabelSelectAll.Visible = True
        LabelSelectAll.Enabled = True

    Case Else
    
        LabelSelectAll.Visible = True
        LabelSelectAll.Enabled = False
    
    End Select

End Function

'
'   clear my grid
'
Public Sub ClearValueRows()
    
    Redimension fxgGrid.FixedRows, fxgGrid.Cols
    
    SetToWidestCellInColumn 0, fxgGrid.Cols - 1
    
    ReDim cellChecked(1 To 1): cellChecked(1) = False
    
    LabelSelectAll.Visible = False
    LabelSelectAll.ForeColor = RGB(0, 0, 0)

    fxgGrid.Redraw = True

End Sub

'
'   enable entire user control
'
Public Property Let Enabled(newValue As Boolean)

    UserControl.Enabled = newValue

End Property

'
'   return specific cell value
'
Public Function GetCellValue(rowIndex As Long, _
                             colIndex As Long)
                             
    With fxgGrid
        
        GetCellValue = .TextMatrix(.FixedRows - 1 + rowIndex, .FixedCols - 1 + colIndex)
                             
    End With
    
End Function

'
'   execute hiding
'
Private Sub HideColumn(colIndex As Long)

    columnHidden(colIndex) = Not columnHidden(colIndex)

    SetToWidestCellInColumn colIndex

End Sub

'
'   return checked status
'
Public Function IsChecked(rowIndex As Long) As Boolean

    IsChecked = cellChecked(rowIndex)

End Function

'
'   container for other useful data
'
Public Property Let OtherData(dataName As String, _
                              newValue)
                                  
    Dim i As Long
    
    For i = LBound(fieldOtherData, 2) To UBound(fieldOtherData, 2)
    
        If fieldOtherData(0, i) = dataName Then
        
            fieldOtherData(1, i) = newValue
    
            Exit Property
    
        End If
    
    Next i
    
    ' dataName not found, add new
    
    Dim newUpper As Long: newUpper = UBound(fieldOtherData, 2) + 1
    
    ReDim Preserve fieldOtherData(1, newUpper)
    
    fieldOtherData(0, newUpper) = dataName
        
    fieldOtherData(1, newUpper) = newValue
    
End Property

'
'   property get container for other useful data
'
Public Property Get OtherData(dataName As String) As Variant
                                  
    Dim i As Long
    
    For i = LBound(fieldOtherData, 2) To UBound(fieldOtherData, 2)
    
        If fieldOtherData(0, i) = dataName Then
        
            OtherData = fieldOtherData(1, i)
    
            Exit Property
    
        End If
    
    Next i
    
    Err.Raise vbObjectError + errorNumberDataNotFound, , _
              "MyGrid OtherData not found: " & dataName
    
End Property


Public Sub FocusToZero()

    fxgGrid.Row = 0
    fxgGrid.Col = 0

    oldRow = 0
    oldCol = 0

End Sub

'
'   remove selected row from grid
'
Public Sub RemoveRow(relRow As Long)

    If ValueRowCount = 1 Then
    
        ClearValueRows
        Exit Sub
    
    End If
    
    If relRow = fieldSelectedRow Then SelectedRow = fieldSelectedRow

    StoreOldAndFreeze
    
    With fxgGrid
    
        Dim tmpRow As Long, tmpCol As Long
        For tmpRow = relRow To fields.ValueRowCount - 1
        
            cellChecked(tmpRow) = cellChecked(tmpRow + 1)
        
            For tmpCol = 0 To .Cols - 1
            
                cellWidths(AbsoluteRow(tmpRow), tmpCol) = cellWidths(AbsoluteRow(tmpRow + 1), tmpCol)
            
            Next tmpCol
            
        Next tmpRow
            
        .RemoveItem AbsoluteRow(relRow)
        
        SetToWidestCellInColumn 0, .Cols - 1
    
    End With
    
    Redimension fxgGrid.Rows, fxgGrid.Cols
    
    CheckedCount
    
    RestoreOld

End Sub


Private Function AbsoluteRow(relRow As Long) As Long

    AbsoluteRow = fxgGrid.FixedRows - 1 + relRow

End Function


Private Function RelativeRow(absRow As Long) As Long

    RelativeRow = absRow - fxgGrid.FixedRows + 1

End Function


Private Function AbsoluteCol(relCol As Long) As Long

    AbsoluteCol = fxgGrid.FixedCols - 1 + relCol

End Function


Private Function RelativeCol(absCol As Long) As Long

    RelativeCol = absCol - fxgGrid.FixedCols + 1

End Function





'
'   property let SelectedRow
'
Public Property Let SelectedRow(Optional StaySelected As Boolean = False, _
                                newSelectedRow As Long)

    If showSelectedRow Then
    
        StoreOldAndFreeze
        
        Dim oldSelectedRow As Long: oldSelectedRow = fieldSelectedRow
        
        If (newSelectedRow = fieldSelectedRow) And _
           (StaySelected = False) Then
        
            fieldSelectedRow = 0
            
        Else
        
            fieldSelectedRow = newSelectedRow
        
        End If
            
        With fxgGrid
        
            Dim j As Long
        
            If Not oldSelectedRow = 0 Then
        
                '   unselect old
                .Row = .FixedRows - 1 + oldSelectedRow
                
                For j = 1 To .Cols - .FixedCols
            
                    .Col = .FixedCols - 1 + j
                    If Not .ColData(.Col) Then
                    
                        .CellBackColor = .BackColor
                        .CellForeColor = .ForeColor
            
                    End If
            
                Next j
                
            End If
        
            If Not fieldSelectedRow = 0 Then
        
                '   select new
                .Row = .FixedRows - 1 + fieldSelectedRow

                For j = 1 To .Cols - .FixedCols

                    .Col = .FixedCols - 1 + j
                    If Not .ColData(.Col) Then
                        
                        .CellBackColor = SelectedRowColor
                        .CellForeColor = SelectedTextColor
                        
                    End If

                Next j

            End If
        
            RaiseEvent ItemSelected(fieldSelectedRow)
        
        End With
        
        RestoreOld
        
    End If

End Property

'
'   property get Selected Row
'
Public Property Get SelectedRow(Optional StaySelected As Boolean = False) As Long

    SelectedRow = fieldSelectedRow
    
End Property


'
'   set new value for a single cell
'
Public Sub SetValueSingle(ByVal newValue As String, _
                          Optional SelectedRow As Long = -1, _
                          Optional selectedCol As Long = -1)
                        
    StoreOldAndFreeze
    
    currentRow = IIf(SelectedRow = -1, currentRow + 1, SelectedRow)
    currentCol = IIf(selectedCol = -1, currentCol + 1, selectedCol)
    
    CellValueSet fxgGrid.FixedRows + currentRow - 1, _
                 fxgGrid.FixedCols + currentCol - 1, _
                 newValue
                        
    SetToWidestCellInColumn fxgGrid.FixedCols + currentCol - 1
    
    RestoreOld
    
End Sub


'
'   set upper left area of headers
'
Public Sub SetHeaderTitle(titleMatrix)

    StoreOldAndFreeze
    
    If (fxgGrid.FixedRows <> UBound(titleMatrix, 1) + 1) Or _
       (fxgGrid.FixedRows <> UBound(titleMatrix, 2) + 1) Then

        Redimension UBound(titleMatrix, 1) + 2, UBound(titleMatrix, 2) + 2, _
                    UBound(titleMatrix, 1) + 1, UBound(titleMatrix, 2) + 1
        
    End If
    
    Dim i As Long, j As Long
    
    For i = 0 To fxgGrid.FixedRows - 1
    
        fxgGrid.RowData(i) = True
        
        For j = 0 To fxgGrid.FixedCols - 1
        
            cellLocked(i, j) = True
            
            fxgGrid.ColData(i) = True
        
            CellValueSet i, j, titleMatrix(i, j)
        
        Next j
        
    Next i

    SetToWidestCellInColumn 0, fxgGrid.FixedCols - 1

    RestoreOld

End Sub


'
'   set row numbers to rowindex and set row titles
'
Public Sub SetHeaderRow(horizontalArray, _
                        Optional rowIndex As Long = -1, _
                        Optional LooksFixed As Boolean = False)


    StoreOldAndFreeze
    
    currentRow = IIf(rowIndex = -1, currentRow + 1, rowIndex)
    
    Redimension fxgGrid.FixedRows + currentRow, fxgGrid.Cols
    
    fxgGrid.RowData(fxgGrid.Rows - 1) = LooksFixed
    
    Dim j As Long
    
    For j = 0 To fxgGrid.FixedCols - 1
    
        fxgGrid.ColData(j) = True
        
        CellValueSet fxgGrid.Rows - 1, j, horizontalArray(j)
        
        cellLocked(fxgGrid.Rows - 1, j) = True
    
    Next j

    SetToWidestCellInColumn 0, fxgGrid.FixedCols - 1

    RestoreOld

End Sub

'
'   set col numbers to colindex and set col titles
'
Public Sub SetHeaderColumn(verticalArray, _
                           Optional columnIndex As Long = -1, _
                           Optional LooksFixed As Boolean = False)


    StoreOldAndFreeze
    
    currentCol = IIf(columnIndex = -1, currentCol + 1, columnIndex)
    
    Redimension fxgGrid.Rows, fxgGrid.FixedCols + currentCol
    
    fxgGrid.ColData(fxgGrid.Cols - 1) = LooksFixed
    
    Dim i As Long
    
    For i = 0 To fxgGrid.FixedRows - 1
        
        fxgGrid.RowData(i) = True
        
        CellValueSet i, fxgGrid.Cols - 1, verticalArray(i)
        
        cellLocked(i, fxgGrid.Cols - 1) = True
    
    Next i

    SetToWidestCellInColumn fxgGrid.Cols - 1, fxgGrid.Cols - 1

    RestoreOld

End Sub


'
'   set values for selected row
'
Public Sub SetValueRow(horizontalArray, _
                       Optional rowIndex As Long = -1)

    StoreOldAndFreeze

    currentRow = IIf(rowIndex = -1, currentRow + 1, rowIndex)
    
    Dim j As Long, k As Long: k = LBound(horizontalArray)
    
    For j = fxgGrid.FixedCols To fxgGrid.Cols - 1
        
        If k <= UBound(horizontalArray) Then
        
            CellValueSet fxgGrid.FixedRows - 1 + currentRow, j, _
                         GiveFormatted(horizontalArray(k))
            
            cellLocked(fxgGrid.FixedRows - 1 + currentRow, j) = False

        Else
        
            CellValueSet fxgGrid.FixedRows - 1 + currentRow, j, " "
        
            cellLocked(fxgGrid.FixedRows - 1 + currentRow, j) = True
        
        End If
        
        k = k + 1
        
    Next j

    SetToWidestCellInColumn fxgGrid.FixedCols, fxgGrid.Cols - 1

    RestoreOld

End Sub

'
'   set values for selected column
'
Public Sub SetValueColumn(verticalArray, _
                          Optional columnIndex As Long = -1)

    StoreOldAndFreeze
    
    currentCol = IIf(columnIndex = -1, currentCol + 1, columnIndex)

    Dim i As Long, k As Long: k = LBound(verticalArray)
    
    For i = fxgGrid.FixedRows To fxgGrid.Rows - 1
        
        If k <= UBound(verticalArray) Then
        
            CellValueSet i, fxgGrid.FixedCols - 1 + currentCol, _
                "." & GiveFormatted(verticalArray(k))
                
            cellLocked(i, fxgGrid.FixedCols - 1 + currentCol) = False
                
        Else
        
            CellValueSet i, fxgGrid.FixedCols - 1 + currentCol, " "
        
            cellLocked(i, fxgGrid.FixedCols - 1 + currentCol) = True
        
        End If
        
        k = k + 1
        
    Next i

    SetToWidestCellInColumn fxgGrid.FixedCols - 1 + currentCol, _
                            fxgGrid.FixedCols - 1 + currentCol

    RestoreOld

End Sub

'
'   property get Value Row Count
'
Public Property Get ValueRowCount() As Long

    ValueRowCount = fields.ValueRowCount

End Property

'
'   property let Value Row Count
'
Public Property Let ValueRowCount(newValue As Long)

    fields.ValueRowCount = newValue
    
    LabelToggleSelectAll.Enabled = Not (newValue = 0)
    LabelSelectAll.Visible = Not (newValue = 0) And LabelSelectAll.Visible

End Property





Private Sub fxgGrid_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)

    With LabelToggleSelectAll
        
        .ForeColor = RGB(0, 0, 0)
        .FontUnderline = False
        
    End With

End Sub


'
'   toggle select all on and off
'
Private Sub LabelToggleSelectAll_Click()
    
    LabelSelectAll.Visible = Not LabelSelectAll.Visible
    LabelSelectAll.Enabled = True
    
    StoreOldAndFreeze
    
    Dim i As Long
    For i = 1 To UBound(cellChecked)
                    
        cellChecked(i) = LabelSelectAll.Visible
    
        fxgGrid.Row = i + fxgGrid.FixedRows - 1
        fxgGrid.Col = 0

        fxgGrid.CellFontName = "Wingdings"
        fxgGrid.CellFontSize = 10
        fxgGrid.CellFontBold = True
        fxgGrid.CellAlignment = flexAlignCenterCenter

        fxgGrid.Text = IIf(cellChecked(i), "", " ")
    
    Next i

    '   check how many checked
    
    CheckedCount

    RestoreOld
    
End Sub




'
'   mouse moving over label
'
Private Sub LabelToggleSelectAll_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)

    With LabelToggleSelectAll
        
        .ForeColor = RGB(0, 0, 255)
        .FontUnderline = True
        
    End With

End Sub


'
'   key pressed on edit text box
'
Private Sub tbCell_KeyPress(KeyAscii As Integer)

    If KeyAscii = 13 Then
        
        KeyAscii = 0
        
    End If
    
    If KeyAscii = 27 Then
    
        tbCellValueChanged = False
    
        tbCell.Visible = False
        
        KeyAscii = 0
        
    End If

End Sub

'
'   click on user control
'
Private Sub UserControl_Click()
    
    fxgGrid.SetFocus

End Sub



' initialize my grid

Private Sub UserControl_Initialize()
    
    Set fxgHandle = fxgGrid
    Set lblCheckHandle = LabelToggleSelectAll
    
    tbCell.Visible = False
    EditEnabled = False

    ReDim cellWidths(1, 1)
    
    ReDim cellLocked(0, 0): cellLocked(0, 0) = True
    
    ReDim columnHidden(0): columnHidden(0) = False
    
    CheckBoxed = False
    ReDim cellChecked(1 To 1): cellChecked(1) = False
    
    Redimension 2, 2
    
    ReDim fieldOtherData(1, 0)
    fieldOtherData(0, 0) = "created"
    fieldOtherData(1, 0) = Now
    
    LabelToggleSelectAll.Visible = False
    LabelSelectAll.Visible = False
    
    showSelectedRow = False
    fieldSelectedRow = 0
    
    fields.selectedRowOriginalColour = fxgGrid.BackColor
    
    ToggleSelectedEnabled = True
    
    CanHideColumn = False
    
End Sub


Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    
    With LabelToggleSelectAll
        
        .ForeColor = RGB(0, 0, 0)
        .FontUnderline = False
        
    End With

End Sub

' resizing my grid

Private Sub UserControl_Resize()
    
    If CheckBoxed Then
    
        fxgGrid.Top = LabelToggleSelectAll.Top + LabelToggleSelectAll.Height + 100
        
    Else
    
        fxgGrid.Top = UserControl.ScaleTop
    
    End If
    
    fxgGrid.Left = UserControl.ScaleLeft
    If UserControl.ScaleWidth - fxgGrid.Left > 0 Then _
        fxgGrid.Width = UserControl.ScaleWidth - fxgGrid.Left
    If UserControl.ScaleHeight - fxgGrid.Top > 0 Then _
        fxgGrid.Height = UserControl.ScaleHeight - fxgGrid.Top

' add code for activating scrollbars
    
End Sub

'
'   changing my grid dimensions
'
Private Sub Redimension(newRows As Long, _
                        newCols As Long, _
                        Optional newFixedRows As Long = 0, _
                        Optional newFixedCols As Long = 0)
    
    With fxgGrid
    
        .Rows = newRows
        .Cols = newCols
    
        If newFixedRows > 0 Then .FixedRows = newFixedRows
        If newFixedCols > 0 Then .FixedCols = newFixedCols
    
        ModuleUtilities.ReDimMatrix cellWidths, 0, newRows, 0, newCols, 0
        ModuleUtilities.ReDimMatrix cellLocked, 0, newRows, 0, newCols, False
        ModuleUtilities.ReDimArray cellChecked, 1, .Rows - .FixedRows, False, True
        ModuleUtilities.ReDimArray columnHidden, 0, .Cols - 1, False, True
    
        ValueRowCount = .Rows - .FixedRows
        ValueColCount = .Cols - .FixedCols
    
    End With
    
End Sub



'
'   seting proper alignment < left, . middle, > rigth
'
Private Sub SetAlignment(stringValue)
    
    Select Case Left(stringValue, 1)
    
    Case "<"
        
        fxgGrid.CellAlignment = flexAlignLeftCenter
        stringValue = Mid(stringValue, 2)
    
    Case ">"
    
        fxgGrid.CellAlignment = flexAlignRightCenter
        stringValue = Mid(stringValue, 2)
    
    Case "."
    
        fxgGrid.CellAlignment = flexAlignCenterCenter
        stringValue = Mid(stringValue, 2)
    
    Case Else
    
        fxgGrid.CellAlignment = flexAlignCenterCenter
    
    End Select
    
End Sub

' handling merging if command present

Private Function Merging(stringValue) As Boolean
                
    If Left(stringValue, 1) = "#" Then
        
        Merging = True
                    
        Dim oldRow As Long: oldRow = fxgGrid.Row
        Dim oldCol As Long: oldCol = fxgGrid.Col
                    
        If Left(stringValue, 2) = "#-" Then fxgGrid.Col = oldCol - 1
        
        If Left(stringValue, 2) = "#|" Then fxgGrid.Row = oldRow - 1
                    
        Dim tmpText As String: tmpText = fxgGrid.Text
        Dim tmpAlignment As AlignmentSettings: tmpAlignment = fxgGrid.CellAlignment
                    
        fxgGrid.Row = oldRow
        fxgGrid.Col = oldCol
        fxgGrid.Text = tmpText
        fxgGrid.CellAlignment = tmpAlignment
                    
        cellWidths(fxgGrid.Row, fxgGrid.Col) = 0
        
        fxgGrid.MergeCells = flexMergeRestrictAll
        
        If Left(stringValue, 2) = "#-" Then
            
'            fxgGrid.MergeCells = flexMergeRestrictRows
            fxgGrid.MergeRow(fxgGrid.Row) = True
        
        End If
        
        If Left(stringValue, 2) = "#|" Then
        
 '           fxgGrid.MergeCells = flexMergeRestrictColumns
            fxgGrid.MergeCol(fxgGrid.Col) = True
            
        End If
                
    Else
    
        Merging = False
        
    End If

End Function

' clear values in selected column

Public Sub ClearColumnValues(selectedCol As Long)

    Dim j As Long
    
    StoreOldAndFreeze
    
    fxgGrid.Col = fxgGrid.FixedCols - 1 + selectedCol
        
    For j = fxgGrid.FixedRows To fxgGrid.Rows - 1
        fxgGrid.Row = j
        fxgGrid.Text = ""
        CalcCellWidth
    Next j
    
    SetToWidestCellInColumn fxgGrid.FixedCols - 1 + selectedCol

    RestoreOld

End Sub

' calculate text width for current cell

Private Sub CalcCellWidth()

    If (CheckBoxed) And (fxgGrid.Col = 0) Then
    
        cellWidths(fxgGrid.Row, fxgGrid.Col) = LabelSelectAll.Width
    
    Else

        UserControl.Font.Name = fxgGrid.CellFontName
        UserControl.Font.Size = fxgGrid.CellFontSize
        UserControl.Font.Bold = fxgGrid.CellFontBold
        UserControl.Font.Italic = fxgGrid.CellFontItalic
        
        cellWidths(fxgGrid.Row, fxgGrid.Col) = UserControl.TextWidth(" " & fxgGrid.Text & " ")
    
    End If
    
End Sub


' calculate widest cell in column and redimension it

Private Sub SetToWidestCellInColumn(fromColumn As Long, Optional toColumn As Long = -1)

    Dim i As Long, j As Long
    Dim widest As Long
    
    If toColumn = -1 Then toColumn = fromColumn
    
    For j = fromColumn To toColumn
    
        widest = 0
        
        If columnHidden(j) Then
        
            widest = defaultHiddenWidth
        
        Else
        
            For i = 0 To UBound(cellWidths, 1)
        
                If widest < cellWidths(i, j) Then widest = cellWidths(i, j)
    
            Next i
    
        End If
        
        fxgGrid.ColWidth(j) = widest
        
    Next j
    
End Sub

' store old settings

Private Sub StoreOldAndFreeze()
    
    oldRedraw = fxgGrid.Redraw
    oldRow = fxgGrid.Row
    oldCol = fxgGrid.Col
    
    fxgGrid.Redraw = False

End Sub

' restore old settings

Private Sub RestoreOld()
    
    fxgGrid.Row = IIf(oldRow > fxgGrid.Rows - 1, fxgGrid.Rows - 1, oldRow)
    fxgGrid.Col = IIf(oldCol > fxgGrid.Cols - 1, fxgGrid.Cols - 1, oldCol)
    fxgGrid.Redraw = oldRedraw

End Sub


'
'   start editing selected cell
'
Public Sub StartEditing(newEditedRow As Long, newEditedCol As Long)

    With fxgGrid
    
        
        .Row = newEditedRow + .FixedRows - 1
        .Col = newEditedCol + .FixedCols - 1
    
        tbCell.FontName = .CellFontName
        tbCell.FontBold = .CellFontBold
        tbCell.FontItalic = .CellFontItalic
        tbCell.FontSize = .CellFontSize
        
        tbCell.Move .Left + .CellLeft, .Top + .CellTop, .CellWidth, .CellHeight
    
        tbCell.Text = .Text
        
        editedRow = newEditedRow
        editedCol = newEditedCol
        
        tbCell.SelStart = 0
        
        tbCell.SelLength = Len(tbCell.Text)
    
    End With
    
    editError = False
    
    tbCellValueChanged = False
    
    tbCell.Visible = True
    
    tbCell.SetFocus

End Sub

'
'   on mouse up
'
Private Sub fxgGrid_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    
    With fxgGrid
        
        CalculateBoundries
        
        If CheckBoxed Then
        
            '   handle checking
            If (x <= xCheckRight) And (y >= yValueTop) Then
            
                If (Shift = 2) And (SelectedRow > 0) Then
                
                    Dim i As Long, Direction As Long
                
                    Direction = IIf(SelectedRow < RelativeRow(.Row), 1, -1)
                    
                    For i = SelectedRow To RelativeRow(.Row) Step Direction
                                            
                        ApplyCheck i
                
                    Next i
                
                    SelectedRow(True) = RelativeRow(.Row)
                
                    Exit Sub
                    
                End If
                
                ApplyCheck RelativeRow(.Row) '.Row - .FixedRows + 1
                
                SelectedRow(True) = RelativeRow(.Row) '.Row - .FixedRows + 1
                
                Exit Sub
        
            End If
            
        End If
        
        If (x <= xValueLeft) Or (x > xValueRight) Then Exit Sub
        
        If (y <= yValueTop) And (x > xValueLeft) Then
        
            If CanHideColumn Then HideColumn .Col
                
            Exit Sub
            
        End If
        
        If (y <= yValueTop) Or (y > yValueBottom) Then Exit Sub
        
        If cellLocked(.Row, .Col) Then Exit Sub
    
        SelectedRow = .Row - .FixedRows + 1
        
        If Not EditEnabled Then Exit Sub
        
        If columnHidden(.Col) Then Exit Sub
        
        tbCell.Visible = False
        
        StartEditing .Row - .FixedRows + 1, .Col - .FixedCols + 1
    
    End With
    
End Sub

'
'   calculate important grid boundries (grafical)
'
Private Sub CalculateBoundries()

    StoreOldAndFreeze
    
    With fxgGrid
        
        '   xValueRight
        If .ColIsVisible(.Cols - 1) Then
            .Col = .Cols - 1
            xValueRight = .CellLeft + .CellWidth
        Else
            xValueRight = .Width
        End If
        
        '   xValueLeft
        If .ColIsVisible(.FixedCols - 1) Then
            .Col = .FixedCols - 1
            xValueLeft = .CellLeft + .CellWidth
        Else
            xValueLeft = .Left
        End If

        '   yValueBottom
        If .RowIsVisible(.Rows - 1) Then
            .Row = .Rows - 1
            yValueBottom = .CellTop + .CellHeight
        Else
            yValueBottom = .Height
        End If

        '   yValueTop
        If .RowIsVisible(.FixedRows - 1) Then
            .Row = .FixedRows - 1
            yValueTop = .CellTop + .CellHeight
        Else
            yValueTop = .Height
        End If

        '   xCheckRight
        xCheckRight = .ColWidth(0)
        
    End With

    RestoreOld

End Sub


'
'   value changed
'
Private Sub tbCell_Change()

    tbCellValueChanged = True

End Sub

'
'   keydown on tbCell
'
Private Sub tbCell_KeyDown(KeyCode As Integer, Shift As Integer)

    If Shift = 0 Then
    
        Dim key As Variant
        
        key = Switch(KeyCode = 37, Array(-1, 0), _
                     KeyCode = 38, Array(0, -1), _
                     KeyCode = 39, Array(1, 0), _
                     KeyCode = 40, Array(0, 1), _
                     KeyCode = 13, Array(1, 1))
    
        If IsNull(key) Then Exit Sub
    
        With fxgGrid
    
            ProcessEditing
            If editError Then
            
                KeyCode = 0
                editError = False
                Exit Sub
                
            End If
            
            '   navigate through grid by cursors; ENTER goes right and down
            Do While True
                
                editedCol = editedCol + key(0)
                If key(0) + key(1) < 2 Then editedRow = editedRow + key(1)  ' not ENTER key
                
                If editedCol < 1 Then editedCol = .Cols - .FixedCols
                
                If editedCol > .Cols - .FixedCols Then
                    
                    editedCol = 1
                    If key(0) + key(1) = 2 Then editedRow = editedRow + 1  ' ENTER key
                
                End If
                
                If editedRow < 1 Then editedRow = .Rows - .FixedRows
                If editedRow > .Rows - .FixedRows Then editedRow = 1
                
                If Not cellLocked(editedRow + .FixedRows - 1, editedCol + .FixedCols - 1) Then Exit Do
                
            Loop
            
            KeyCode = 0
            
            StartEditing editedRow, editedCol
            
        End With
    
    End If

End Sub

'
'   data enter text box lost focus
'
Private Sub tbCell_LostFocus()
    
    tbCell.Visible = False
    
    ProcessEditing
    
End Sub


'
'   actually process editing
'
Private Sub ProcessEditing()

    If tbCellValueChanged Then
    
        RaiseEvent CellValueChanged(editedRow, editedCol, tbCell.Text)
    
        tbCellValueChanged = False
    
    End If

End Sub

'
'   export grid to txt file with selected column delimiter
'
Public Sub ExportGrid(filePath As String, Optional delimiter As String = vbTab)

    Dim fNo As Long: fNo = FreeFile
    
    Dim buff As String
    Open filePath For Output As #fNo
    
    Dim r As Long, c As Long
    
    For r = 0 To fxgGrid.Rows - 1
    
        buff = r
        
        For c = 0 To fxgGrid.Cols - 1
        
            buff = buff & delimiter & fxgGrid.TextMatrix(r, c)
        Next c
    
        Print #fNo, buff
    Next r
    
    Close fNo
End Sub

