VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.ocx"
Begin VB.UserControl MyRichTextBox 
   ClientHeight    =   2385
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3615
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   8.25
      Charset         =   238
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ScaleHeight     =   2385
   ScaleWidth      =   3615
   Begin VB.Frame FrameDelimeter 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   238
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1695
      Left            =   1560
      MousePointer    =   9  'Size W E
      TabIndex        =   4
      Top             =   480
      Width           =   135
   End
   Begin RichTextLib.RichTextBox rtbHost 
      Height          =   1695
      Index           =   1
      Left            =   120
      TabIndex        =   0
      Top             =   480
      Width           =   1455
      _ExtentX        =   2566
      _ExtentY        =   2990
      _Version        =   393217
      ScrollBars      =   3
      RightMargin     =   1e7
      AutoVerbMenu    =   -1  'True
      TextRTF         =   $"MyRichTextBox.ctx":0000
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin RichTextLib.RichTextBox rtbHost 
      Height          =   1695
      Index           =   2
      Left            =   1800
      TabIndex        =   3
      Top             =   480
      Width           =   1455
      _ExtentX        =   2566
      _ExtentY        =   2990
      _Version        =   393217
      ScrollBars      =   3
      RightMargin     =   1e7
      AutoVerbMenu    =   -1  'True
      TextRTF         =   $"MyRichTextBox.ctx":0089
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.Label lbName 
      Appearance      =   0  'Flat
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      BackStyle       =   0  'Transparent
      Caption         =   "Name"
      ForeColor       =   &H00000000&
      Height          =   210
      Index           =   2
      Left            =   1920
      TabIndex        =   2
      Top             =   120
      Width           =   465
   End
   Begin VB.Label lbName 
      Appearance      =   0  'Flat
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      BackStyle       =   0  'Transparent
      Caption         =   "Name"
      ForeColor       =   &H00000000&
      Height          =   210
      Index           =   1
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   465
   End
End
Attribute VB_Name = "MyRichTextBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'---------------------------------------
' TO DO:
'   - add comments and documentation
'---------------------------------------

Private Const edge = 100            ' graphical edge

Private resizing As Boolean         ' rtb resizing flag

Private xHandle As Single           ' x handle for resizing

Private typicalPosition As Long     ' -1: not set (free hand), 0: left, 1: middle, 2: right

'
'   handle delimeter moving (left or right)
'
Private Sub PositionDelimeter(newLeftPosition As Long)

    Dim positionBorder As Long

    UserControl.FontName = lbName(1).FontName
    UserControl.FontSize = lbName(1).FontSize
    UserControl.FontBold = lbName(1).FontBold
    UserControl.FontItalic = lbName(1).FontItalic
    
    positionBorder = rtbHost(1).Left + TextWidth(lbName(1)) + edge
    If newLeftPosition < positionBorder Then newLeftPosition = positionBorder
    
    positionBorder = rtbHost(2).Left + rtbHost(2).Width - TextWidth(lbName(2)) - 2 * edge
    If newLeftPosition > positionBorder Then newLeftPosition = positionBorder
    
    FrameDelimeter.Left = newLeftPosition
    
    lbName(1).Left = UserControl.ScaleLeft + edge
    lbName(2).Left = FrameDelimeter.Left + FrameDelimeter.Width
    
    Dim tempWidth As Long
    tempWidth = FrameDelimeter.Left - lbName(1).Left
    If tempWidth > 0 Then lbName(1).Width = tempWidth
    tempWidth = UserControl.ScaleWidth - (FrameDelimeter.Left + FrameDelimeter.Width + edge)
    If tempWidth > 0 Then lbName(2).Width = tempWidth
    
    rtbHost(1).Left = lbName(1).Left
    rtbHost(2).Left = lbName(2).Left

    rtbHost(1).Width = lbName(1).Width
    rtbHost(2).Width = lbName(2).Width
    
End Sub

'
'   calculate next of significant positions (left, middle, right)
'
Private Sub FrameDelimeter_DblClick()

    If typicalPosition = -1 Then
    
        Select Case FrameDelimeter.Left
        
        Case Is > 3 * (UserControl.ScaleWidth - 2 * edge) / 4: typicalPosition = 2
        
        Case Is < (UserControl.ScaleWidth - 2 * edge) / 4: typicalPosition = 0
            
        Case Else: typicalPosition = 1
            
        End Select
    
    Else
    
        typicalPosition = typicalPosition + 1
        
        If typicalPosition > 2 Then typicalPosition = 0
    
    End If
    
    Select Case typicalPosition
    
    Case 0: PositionDelimeter 0
    
    Case 1: PositionDelimeter (UserControl.ScaleWidth - FrameDelimeter.Width) / 2

    Case 2: PositionDelimeter UserControl.ScaleWidth
    
    End Select

End Sub

'
'   mouse down for resizing
'
Private Sub FrameDelimeter_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)

    resizing = True

    xHandle = x

End Sub

'
'   actual resizing
'
Private Sub FrameDelimeter_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)

    If resizing Then
        
        PositionDelimeter FrameDelimeter.Left + (x - xHandle)
        
        typicalPosition = -1
        
    End If

End Sub

'
'   mouse up: end resizing
'
Private Sub FrameDelimeter_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)

    resizing = False

End Sub

'
'   initialize instance of MyRichTextBox control
'
Private Sub UserControl_Initialize()

    lbName(1).Caption = "BOX (1)"
    lbName(2).Caption = "BOX (2)"
    
    
    
    rtbHost(1).Text = ""
    rtbHost(2).Text = ""

    typicalPosition = 1

End Sub

'
'   properly stretch rtbs and labels over control
'
Private Sub UserControl_Resize()

    FrameDelimeter.BorderStyle = 0
    
    FrameDelimeter.Top = UserControl.ScaleTop + edge
    
    Dim tempHeight As Long
    
    tempHeight = UserControl.ScaleHeight - (FrameDelimeter.Top + edge)
    If tempHeight > 0 Then FrameDelimeter.Height = tempHeight
        
    lbName(1).Top = FrameDelimeter.Top
    lbName(2).Top = FrameDelimeter.Top
    
    rtbHost(1).Top = lbName(1).Top + lbName(1).Height + edge
    rtbHost(2).Top = lbName(2).Top + lbName(2).Height + edge
    
    tempHeight = UserControl.ScaleHeight - rtbHost(1).Top - edge
    If tempHeight > 0 Then rtbHost(1).Height = tempHeight
    
    tempHeight = UserControl.ScaleHeight - rtbHost(2).Top - edge
    If tempHeight > 0 Then rtbHost(2).Height = tempHeight

    PositionDelimeter (UserControl.ScaleWidth - FrameDelimeter.Width) / 2

End Sub

'
'   set box name and label
'
Public Sub SetBoxName(Index As Long, newName As String)
    
    lbName(Index).Caption = newName

End Sub

'
'   load file into selected rtb, message if error and return false, else return true
'
Public Function LoadFile(boxIndex As Long, _
                         fileName As String) As Boolean

On Error GoTo errorLoadFile
    
    rtbHost(boxIndex).LoadFile fileName
    
    LoadFile = True
    Exit Function

errorLoadFile:
    
    Err.Raise Err.Number, , "Rich Text Box load file error." & _
                            NewLine("Box name: " & lbName(boxIndex)) & _
                            NewLine("File: " & fileName) & _
                            NewLine(Err.Description)

    LoadFile = False

End Function

'
'   print file if exists
'
Public Function PrintFile(boxIndex As Long) As Boolean

On Error GoTo errorPrintFile
    
    If rtbHost(boxIndex).fileName <> "" Then
    
        rtbHost(boxIndex).SelLength = 0
        rtbHost(boxIndex).SelPrint Printer.hDC
    
        PrintFile = True
        
    End If
    
    Exit Function

errorPrintFile:
    
    Err.Raise Err.Number, , "Rich Text Box print file error." & _
                            NewLine("Box name: " & lbName(boxIndex)) & _
                            NewLine("File: " & fileName) & _
                            NewLine(Err.Description)

    PrintFile = False

End Function


'
'   clear rtb with given name
'
Public Sub Clear(boxIndex As Long)

On Error GoTo errorClearRtb
    
    rtbHost(boxIndex).Text = ""
    
    Exit Sub

errorClearRtb:
    
' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
' ERROR HANDLER SHOULD ONLY RAISE ERROR, user should give message !!!!!!!!!!!!!
    MsgBox ("Error clearing rich text box named " & lbName(boxIndex) & Chr(13) & Chr(10) & _
            "#" & Err.Number & ": " & Err.Description)

End Sub
